<script setup>
const form = ref({
  subject: '',
  message: '',
  firstname: '',
  lastname: '',
  phone: '',
  email: '',
  organization: '',
});

const mailSent = ref(false);
const mailError = ref(false);

const { required, max, email } = useRules();

const { validate, errors } = useValidation(form, {
  subject: [required, (val) => max(val, 250)],
  message: [required],
  firstname: [required, (val) => max(val, 250)],
  lastname: [required, (val) => max(val, 250)],
  phone: [(val) => max(val, 250)],
  email: [required, (val) => max(val, 250), email],
  organization: [(val) => max(val, 250)],
});

const submit = async () => {
  if (mailSent.value) {
    return;
  }

  for (const field of Object.keys(form.value)) {
    validate(field);
  }

  if (Object.keys(errors.value).length) {
    return;
  }

  const mail = useMail();

  try {
    await mail.send({
      from: useRuntimeConfig().public.mailFrom,
      subject: form.value.subject,
      text: `De : ${form.value.firstname} ${form.value.lastname}
Adresse e-mail : ${form.value.email}
Téléphone : ${form.value.phone}
Structure : ${form.value.organization}

~~~
${form.value.message}`,
    });

    mailSent.value = true;
  } catch (e) {
    mailError.value = true;
  }
};
</script>

<template>
  <form @submit.prevent="submit">
    <div class="mb-4">
      <label for="subject">
        <div class="mb-1">{{ $t('pages.contact.form.inputs.0.label') }}</div>

        <WithError v-slot="{ withErrorClass }" :error="errors.subject">
          <input
            id="subject"
            v-model.trim="form.subject"
            type="text"
            :class="[
              'w-full',
              'h-9',
              'px-2',
              'rounded-md',
              'shadow-lg',
              'border',
              'outline-none',
              'focus:ring',
              'dark:bg-las-d-prune',
              ...withErrorClass,
            ]"
            @blur="() => validate('subject')"
          />
        </WithError>
      </label>
    </div>

    <div class="mb-4">
      <label for="message">
        <div class="mb-1">{{ $t('pages.contact.form.inputs.1.label') }}</div>

        <WithError v-slot="{ withErrorClass }" :error="errors.message">
          <textarea
            id="message"
            v-model.trim="form.message"
            rows="4"
            :class="[
              'w-full',
              'py-1',
              'px-2',
              'rounded-md',
              'shadow-lg',
              'border',
              'outline-none',
              'focus:ring',
              'dark:bg-las-d-prune',
              ...withErrorClass,
            ]"
            @blur="() => validate('message')"
          ></textarea>
        </WithError>
      </label>
    </div>

    <div class="mb-4 flex flex-col md:flex-row gap-4">
      <label class="flex-1" for="phone">
        <div class="mb-1">{{ $t('pages.contact.form.inputs.2.label') }}</div>

        <WithError v-slot="{ withErrorClass }" :error="errors.phone">
          <input
            id="phone"
            v-model.trim="form.phone"
            type="text"
            :class="[
              'w-full',
              'h-9',
              'px-2',
              'rounded-md',
              'shadow-lg',
              'border',
              'outline-none',
              'focus:ring',
              'dark:bg-las-d-prune',
              ...withErrorClass,
            ]"
            @blur="() => validate('phone')"
          />
        </WithError>
      </label>

      <label class="flex-1" for="email">
        <div class="mb-1">{{ $t('pages.contact.form.inputs.3.label') }}</div>

        <WithError v-slot="{ withErrorClass }" :error="errors.email">
          <input
            id="email"
            v-model.trim="form.email"
            type="email"
            :class="[
              'w-full',
              'h-9',
              'px-2',
              'rounded-md',
              'shadow-lg',
              'border',
              'outline-none',
              'focus:ring',
              'dark:bg-las-d-prune',
              ...withErrorClass,
            ]"
            @blur="() => validate('email')"
          />
        </WithError>
      </label>
    </div>

    <div class="mb-4 flex flex-col md:flex-row gap-4">
      <label class="flex-1" for="firstname">
        <div class="mb-1">{{ $t('pages.contact.form.inputs.4.label') }}</div>

        <WithError v-slot="{ withErrorClass }" :error="errors.firstname">
          <input
            id="firstname"
            v-model.trim="form.firstname"
            type="text"
            :class="[
              'w-full',
              'h-9',
              'px-2',
              'rounded-md',
              'shadow-lg',
              'border',
              'outline-none',
              'focus:ring',
              'dark:bg-las-d-prune',
              ...withErrorClass,
            ]"
            @blur="() => validate('firstname')"
          />
        </WithError>
      </label>

      <label class="flex-1" for="lastname">
        <div class="mb-1">{{ $t('pages.contact.form.inputs.5.label') }}</div>

        <WithError v-slot="{ withErrorClass }" :error="errors.lastname">
          <input
            id="lastname"
            v-model.trim="form.lastname"
            type="text"
            :class="[
              'w-full',
              'h-9',
              'px-2',
              'rounded-md',
              'shadow-lg',
              'border',
              'outline-none',
              'focus:ring',
              'dark:bg-las-d-prune',
              ...withErrorClass,
            ]"
            @blur="() => validate('lastname')"
          />
        </WithError>
      </label>

      <label class="flex-1" for="organization">
        <div class="mb-1">{{ $t('pages.contact.form.inputs.6.label') }}</div>

        <WithError v-slot="{ withErrorClass }" :error="errors.organization">
          <input
            id="organization"
            v-model.trim="form.organization"
            type="text"
            :class="[
              'w-full',
              'h-9',
              'px-2',
              'rounded-md',
              'shadow-lg',
              'border',
              'outline-none',
              'focus:ring',
              'dark:bg-las-d-prune',
              ...withErrorClass,
            ]"
            @blur="() => validate('organization')"
          />
        </WithError>
      </label>
    </div>

    <div class="flex flex-wrap content-center">
      <button
        type="submit"
        :class="[
          'w-full',
          'bg-las-orange',
          'text-white',
          'rounded-full',
          'px-4',
          'py-1',
          'mb-4',
          'hover:opacity-80',
          'active:opacity-70',
          'dark:bg-las-d-orange',
          'disabled:bg-white',
          'disabled:text-las-orange',
          'disabled:border',
          'disabled:border-las-orange',
          'disabled:opacity-50',
          'disabled:cursor-not-allowed',
          'dark:disabled:bg-las-d-prune',
          'dark:disabled:text-las-d-orange',
          'dark:disabled:border',
          'dark:disabled:border-las-d-orange',
        ]"
        :disabled="Object.keys(errors).length || mailSent"
      >
        {{ $t('pages.contact.form.btn') }}
      </button>

      <span v-show="mailSent" class="text-las-green">
        {{ $t('pages.contact.form.success') }}
      </span>

      <span v-show="mailError" class="text-red-500">
        {{ $t('pages.contact.form.error') }}
      </span>
    </div>
  </form>
</template>
